package me.Demon.DemonGemsSocket;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.List;

public abstract class GemsAPI {

    public static String getname(String games_key){
        FileConfiguration yml = Main.plugin.getConfig();
        return yml.getString("Games."+games_key+".name");
    }

    public static int getchance(String games_key){
        FileConfiguration yml = Main.plugin.getConfig();
        return yml.getInt("Games."+games_key+".chance");
    }

    public static String gettype(String games_key){
        FileConfiguration yml = Main.plugin.getConfig();
        return yml.getString("Games."+games_key+".type");
    }

    public static ItemStack getItems(String games_key){
        FileConfiguration yml = Main.plugin.getConfig();
        ItemStack item = yml.getItemStack("Items."+games_key).clone();
        ItemMeta meta = item.getItemMeta();
        meta.addItemFlags(ItemFlag.HIDE_ENCHANTS);
        meta.addEnchant(Enchantment.PROTECTION_ENVIRONMENTAL,1,true);
        item.setItemMeta(meta);
        return item;
    }

    public static String getGems_Key(ItemStack item){
        ItemMeta meta = item.getItemMeta();
        FileConfiguration yml =  Main.plugin.getConfig();
        for (String key : yml.getConfigurationSection("Games").getKeys(false)){
            String name = yml.getString("Games."+key+".name");
            if(meta.getDisplayName().equalsIgnoreCase(name)){
                return key;
            }
        }
        return null;
    }
}
