package me.Demon.DemonGemsSocket;

import me.Demon.DemonGemsSocket.Item.Rod_Unlock;
import me.Demon.DemonGemsSocket.Remove.GemRemove;
import me.Demon.DemonGemsSocket.listener.*;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.HashMap;
import java.util.List;
import java.util.Random;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static String prefix = "§7[§6宝石§7] §f";
    public static String EmptyLore = "§7- < §1§5§r§7空§1§5§r§7 >";
    public static HashMap<String, String> GemHashMap = new HashMap<>();

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        for (String gemKey : getConfig().getConfigurationSection("Games").getKeys(false)) {
            String name = getConfig().getString("Games." + gemKey + ".name");
            String replore = "§1§6§r§8- §8< " + name + " §8>§1§6§r";
            GemHashMap.put(replore, gemKey);
        }
        Bukkit.getConsoleSender().sendMessage("§6[宝石镶嵌] §f载入宝石: §e" + GemHashMap.size() + "颗");
        Bukkit.getPluginManager().registerEvents(new GemsListGui(), plugin);
        Bukkit.getPluginManager().registerEvents(new GemsOpen(), plugin);
        Bukkit.getPluginManager().registerEvents(new GemsGuiEvent(), plugin);
        Bukkit.getPluginManager().registerEvents(new GemsGuiClose(), plugin);
        Bukkit.getPluginManager().registerEvents(new Rod_Unlock(), plugin);
        Bukkit.getPluginManager().registerEvents(new GemRemove(), plugin);
        Bukkit.getConsoleSender().sendMessage("§6[宝石镶嵌] §a插件成功载入Server！");
        Bukkit.getConsoleSender().sendMessage("§6[宝石镶嵌] §a妖魂QQ:1763917516");
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§6[宝石镶嵌] §c插件已正常关闭！");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String CommandLabel, String[] args) {
        if (CommandLabel.equalsIgnoreCase("socketpro") && sender.isOp()) {
            if (args.length == 0) {
                sender.sendMessage("§r");
                sender.sendMessage("§e------- ======= §6镶嵌宝石系统 §e======= -------");
                sender.sendMessage("§2/socketpro open §f- §2打开宝石库");
                sender.sendMessage("§2/socketpro chaichu §f- §2打开拆除台");
                sender.sendMessage("§2/socketpro giveall §e[宝石代号] §f- §2给予在线玩家1颗宝石");
                sender.sendMessage("§2/socketpro give §e[宝石代号] §2<数量> §f- §2给予宝石");
                sender.sendMessage("§2/socketpro give §e[宝石代号] §2<数量> §b<玩家> §f- §2给予宝石");
                sender.sendMessage("§2/socketpro givepro §e[宝石代号] §2<数量> §b<玩家> §f- §2给予神护宝石");
                sender.sendMessage("§e------- ======= §6镶嵌宝石系统 §e======= -------");
                sender.sendMessage("§r");
            }
            // socket give <gems_key> <amount> <player>
            if (args.length == 1 && args[0].equalsIgnoreCase("open")) {
                GemsListGui.OpenGui((Player) sender);
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("chaichu")) {
                GemRemove.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("giveall")) {
                String gems_key = args[1];
                if (GemsAPI.getchance(gems_key) <= 10) {
                    sender.sendMessage(Main.prefix + "宝石可能不存在，请检查配置。");
                    return true;
                }
                int cont = 0;
                int amount = 1;
                ItemStack item = GemsAPI.getItems(gems_key);
                item.setAmount(amount);
                for (Player p : Bukkit.getOnlinePlayers()) {
                    p.getInventory().addItem(item);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                    p.sendMessage(Main.prefix + "你从 §e" + sender.getName() + " §a那收到了一颗 §r" + item.getItemMeta().getDisplayName());
                    cont++;
                }
                sender.sendMessage(Main.prefix + "本次总计发放 §e" + cont + "颗 §r" + item.getItemMeta().getDisplayName());
            }
            if (args.length == 3 && args[0].equalsIgnoreCase("give")) {
                String gems_key = args[1];
                if (GemsAPI.getchance(gems_key) <= 10) {
                    sender.sendMessage(Main.prefix + "宝石可能不存在，请检查配置。");
                    return true;
                }
                int amount = Integer.parseInt(args[2]);
                if (amount < 1) {
                    sender.sendMessage(Main.prefix + "宝石数量必须大于或等于1。");
                    return true;
                }
                Player p = (Player) sender;
                ItemStack item = GemsAPI.getItems(gems_key);
                item.setAmount(amount);
                p.getInventory().addItem(item);
                p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                sender.sendMessage(Main.prefix + "给予 §6" + amount + "x" + item.getItemMeta().getDisplayName() + " §a给 §e" + p.getName());
            }
            if (args.length == 4 && args[0].equalsIgnoreCase("give")) {
                String gems_key = args[1];
                if (GemsAPI.getchance(gems_key) <= 10) {
                    sender.sendMessage(Main.prefix + "宝石可能不存在，请检查配置。");
                    return true;
                }
                int amount = Integer.parseInt(args[2]);
                if (amount < 1) {
                    sender.sendMessage(Main.prefix + "宝石数量必须大于或等于1。");
                    return true;
                }
                Player p = Bukkit.getPlayer(args[3]);
                if (p != null) {
                    ItemStack item = GemsAPI.getItems(gems_key);
                    item.setAmount(amount);
                    p.getInventory().addItem(item);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                    sender.sendMessage(Main.prefix + "给予 §6" + amount + "x" + item.getItemMeta().getDisplayName() + " §a给 §e" + p.getName());
                } else {
                    sender.sendMessage(Main.prefix + "目标玩家不在线。");
                }
            }
            if (args.length == 4 && args[0].equalsIgnoreCase("givepro")) {
                String gems_key = args[1];
                if (GemsAPI.getchance(gems_key) <= 10) {
                    sender.sendMessage(Main.prefix + "宝石可能不存在，请检查配置。");
                    return true;
                }
                int amount = Integer.parseInt(args[2]);
                if (amount < 1) {
                    sender.sendMessage(Main.prefix + "宝石数量必须大于或等于1。");
                    return true;
                }
                Player p = Bukkit.getPlayer(args[3]);
                if (p != null) {
                    ItemStack item = GemsAPI.getItems(gems_key);
                    item.setAmount(amount);
                    ItemMeta meta = item.getItemMeta();
                    List<String> lore = meta.getLore();
                    for (int i = 0; i < lore.size(); i++) {
                        String s = lore.get(i);
                        if (s.contains("§e▶ §7神护: §c§l✘")) {
                            lore.set(i, "§e▶ §7神护: §a§l✔");
                            break;
                        }
                    }
                    meta.setLore(lore);
                    item.setItemMeta(meta);
                    p.getInventory().addItem(item);
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                    sender.sendMessage(Main.prefix + "给予 §6" + amount + "x" + item.getItemMeta().getDisplayName() + " §a给 §e" + p.getName());
                } else {
                    sender.sendMessage(Main.prefix + "目标玩家不在线。");
                }
            }
        }
        return false;
    }

    public static boolean itemIsNull(ItemStack item) {
        return item == null || item.getType() == Material.AIR;
    }

    public static boolean itemIsLore(ItemStack item) {
        return item.getItemMeta().getLore() == null;
    }

    public static int getRandomInt(int max, int mix) {
        return new Random().nextInt(max) + mix;
    }

    public static int getEmptySlotCount(Player p) {
        int count = 0;
        Inventory inv = p.getInventory();
        for (int i = 0; i < 36; i++) {
            ItemStack item = inv.getItem(i);
            if (itemIsNull(item)) {
                count++;
            }
        }
        return count;
    }

}
