package me.Demon.DemonGemsSocket.listener;

import me.Demon.DemonGemsSocket.GemsAPI;
import me.Demon.DemonGemsSocket.Main;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.scheduler.BukkitRunnable;

public class GemsOpen implements Listener {

    @EventHandler
    public void onClickGems(PlayerInteractEvent e){
        Player p = e.getPlayer();
        ItemStack item = p.getItemInHand();
        if(!Main.itemIsNull(item) && !Main.itemIsLore(item)){
            ItemMeta meta = item.getItemMeta();
            if(meta.getLore().contains("§c提示: §7手持宝石右键镶嵌")){
               if(item.getAmount() >= 2) {
                   p.sendMessage(Main.prefix + "镶嵌失败，每次最多镶嵌一颗宝石。");
                   p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                   return;
               }
                if (GemsAPI.getGems_Key(item) == null) {
                    p.sendMessage(Main.prefix + "宝石配置出现错误，请联系管理员。");
                    p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                    return;
                }
                GemsGui.OpenGui(p, item);
                p.getInventory().setItemInHand(new ItemStack(Material.AIR));
                p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
            }
        }
    }

}
