package me.Demon.DemonGemsSocket.Item;

import me.Demon.DemonGemsSocket.GemsAPI;
import me.Demon.DemonGemsSocket.Main;
import me.Demon.DemonGemsSocket.listener.GemsGui;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class Rod_Unlock implements Listener {

    public static ItemStack setItem_UnlockEvent(ItemStack items){
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        List<String> lore = meta.getLore();
        for (int i = 0;i < lore.size();i++){
            String s = lore.get(i);
            if (s.contains("§7- < §1§5§r§7已锁定§1§5§r§7 >")){
                lore.set(i,Main.EmptyLore);
                break;
            }
        }
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    // 玩家在背包中点击献祭宝典拿起来点击魂环事件
    @EventHandler
    public void onOpenclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory().getType() == InventoryType.CRAFTING) {
            // 判断点击起来的物品是否是拆除器
            int type = 0;
            ItemStack book = e.getCursor();
            if (!Main.itemIsNull(book) && !Main.itemIsLore(book)) {
                ItemMeta meta = book.getItemMeta();
                if(meta.getDisplayName().equalsIgnoreCase("§7[§e宝石§7]§d小黑子开孔器")){
                    type = 1;
                }else if(meta.getDisplayName().equalsIgnoreCase("§7[§e宝石§7]§d顶级开孔器")){
                    type = 2;
                }
            }else{
                return;
            }
            // 获取点击物品是否是魂环
            ItemStack item = e.getCurrentItem();
            if(!Main.itemIsNull(item) && !Main.itemIsLore(item)) {
                ItemMeta meta = item.getItemMeta();
                if(type == 1) {
                    if (!book.getItemMeta().getDisplayName().equalsIgnoreCase("§7[§e宝石§7]§d小黑子开孔器")) {
                        return;
                    }
                    if (book.getAmount() >= 2) {
                        p.sendMessage(Main.prefix + "开孔失败，每次最多使用一个开孔器");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    if (!meta.getLore().contains("§7- < §1§5§r§7已锁定§1§5§r§7 >")) {
                        p.sendMessage(Main.prefix + "开孔失败，该物品可能并不存在为解锁宝石槽");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    if (item.getAmount() >= 2) {
                        p.sendMessage(Main.prefix + "开孔失败，每次最多为一个物品进行此操作。");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    if(Main.getRandomInt(100,1) >= 40){
                        e.setCursor(new ItemStack(Material.AIR));
                        p.sendMessage(Main.prefix + "开孔失败，损失了一个 §7[§e宝石§7]§d小黑子开孔器");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    // 扣除物品
                    e.setCursor(new ItemStack(Material.AIR));
                    // 修改物品的Lore
                    ItemStack new_item = setItem_UnlockEvent(item);
                    e.setCurrentItem(new_item);
                    p.sendMessage(Main.prefix + "开孔成功，已解锁宝石槽位一个。");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                } else {
                    if (!book.getItemMeta().getDisplayName().equalsIgnoreCase("§7[§e宝石§7]§d顶级开孔器")) {
                        return;
                    }
                    if (book.getAmount() >= 2) {
                        p.sendMessage(Main.prefix + "开孔失败，每次最多使用一个开孔器");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    if (!meta.getLore().contains("§7- < §1§5§r§7已锁定§1§5§r§7 >")) {
                        p.sendMessage(Main.prefix + "开孔失败，该物品可能并不存在为解锁宝石槽");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    if (item.getAmount() >= 2) {
                        p.sendMessage(Main.prefix + "开孔失败，每次最多为一个物品进行此操作。");
                        p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, 1, 2);
                        return;
                    }
                    // 扣除物品
                    e.setCursor(new ItemStack(Material.AIR));
                    // 修改物品的Lore
                    ItemStack new_item = setItem_UnlockEvent(item);
                    e.setCurrentItem(new_item);
                    p.sendMessage(Main.prefix + "开孔成功，已解锁宝石槽位一个。");
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 2);
                }
            }
        }
    }
}
