package me.Demon.DemonGemsSocket.Remove;

import me.Demon.DemonGemsSocket.GemsAPI;
import me.Demon.DemonGemsSocket.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class GemRemove implements Listener {

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        if (inv != null && "战争领域 - 宝石拆除台".equalsIgnoreCase(inv.getTitle())) {
            int slot = e.getRawSlot();
            ItemStack click_item = e.getCurrentItem();
            if (slot >= 0 && slot < 27) {
                e.setCancelled(true);
                if (slot == 20) {
                    if (click_item.getTypeId() == 160) {
                        ItemStack item = e.getCursor();
                        if (!Main.itemIsNull(item) && !Main.itemIsLore(item)) {
                            inv.setItem(slot, item);
                            e.setCursor(new ItemStack(Material.AIR));
                            setCheckGem(inv, item);
                            p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, (float) 0.6, (float) 1.8);
                        } else {
                            p.sendMessage(Main.prefix + "该物品无法放入槽位中.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                        }
                    } else {
                        if (!Main.itemIsNull(e.getCursor())) {
                            p.sendMessage(Main.prefix + "请将物品槽中的物品取出后再放入.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                            return;
                        }
                        for (int i = 0; i < 9; i++) {
                            e.getInventory().setItem(i, glass(0, "§7[§c宝石槽§7]"));
                        }
                        e.setCursor(e.getCurrentItem());
                        e.getInventory().setItem(slot, glass(0, "§7[§6装备槽§7]"));
                        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, (float) 0.6, (float) 1.8);
                    }
                }
                if (slot == 24) {
                    if (click_item.getTypeId() == 160) {
                        ItemStack item = e.getCursor();
                        if (!Main.itemIsNull(item) && !Main.itemIsLore(item)) {
                            ItemMeta meta = item.getItemMeta();
                            if (!meta.getDisplayName().contains("拆除器")) {
                                p.sendMessage(Main.prefix + "该槽位只能放入宝石拆除器.");
                                p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                                return;
                            }
                            inv.setItem(slot, item);
                            e.setCursor(new ItemStack(Material.AIR));
                            p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, (float) 0.6, (float) 1.8);
                        } else {
                            p.sendMessage(Main.prefix + "该物品无法放入槽位中.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                        }
                    } else {
                        if (!Main.itemIsNull(e.getCursor())) {
                            p.sendMessage(Main.prefix + "请将物品槽中的物品取出后再放入.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                            return;
                        }
                        e.setCursor(e.getCurrentItem());
                        e.getInventory().setItem(slot, glass(0, "§7[§6拆除器§7]"));
                        p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, (float) 0.6, (float) 1.8);
                    }
                }
                if (slot < 9) {
                    ItemStack item = e.getCurrentItem();
                    if (!Main.itemIsLore(item)) {
                        // 获取拆除槽物品是否存在.
                        ItemStack chaichu = inv.getItem(24);
                        if (Main.itemIsNull(chaichu) || Main.itemIsLore(chaichu)) {
                            p.sendMessage(Main.prefix + "拆除失败,你需要放一个拆除器.");
                            p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                            return;
                        }
                        int type = 1;
                        if (chaichu.getItemMeta().getLore().contains("§e▶ §7成功几率: §a100%")) {
                            type = 2;
                        }
                        if (type == 1) {
                            if (Main.getRandomInt(100, 1) >= 35) {
                                inv.setItem(24, glass(0, "§7[§6拆除器§7]"));
                                p.sendMessage(Main.prefix + "拆除失败，损失了一个 §7[§e宝石§7]§d小黑子拆除器");
                                p.playSound(p.getLocation(), Sound.ENTITY_BLAZE_DEATH, (float) 0.6, (float) 1.8);
                                return;
                            }
                        }
                        // 设置玩家物品的lore为空
                        ItemStack zb_item = inv.getItem(20).clone();
                        ItemMeta zb_meta = zb_item.getItemMeta();
                        int line = Integer.parseInt(item.getItemMeta().getDisplayName().split("§8#")[1]);
                        List<String> lore = zb_meta.getLore();
                        lore.set(line, Main.EmptyLore);
                        zb_meta.setLore(lore);
                        zb_item.setItemMeta(zb_meta);
                        inv.setItem(20, zb_item);
                        // 给予玩家宝石
                        ItemStack gem_item = recoverGemItems(e.getCurrentItem());
                        p.getInventory().addItem(gem_item);
                        // 执行拆除成功的操作
                        inv.setItem(slot, glass(0, "§7[§c宝石槽§7]"));
                        inv.setItem(24, glass(0, "§7[§6拆除器§7]"));
                        p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, (float) 0.6, (float) 1.8);
                    }
                }
            }
        }
    }

    public static ItemStack recoverGemItems(ItemStack items) {
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(meta.getDisplayName().split("§8#")[0]);
        item.setItemMeta(meta);
        return item;
    }

    public static void setCheckGem(Inventory inv, ItemStack item) {
        List<String> gemList = getGemCheckList(item);
        if (gemList.size() >= 1) {
            for (int i = 0; i < gemList.size(); i++) {
                String gemKey = gemList.get(i).split("#")[0];
                String line = gemList.get(i).split("#")[1];
                ItemStack gem_item = GemsAPI.getItems(gemKey);
                ItemMeta meta = gem_item.getItemMeta();
                meta.setDisplayName(meta.getDisplayName() + "§8#" + line);
                gem_item.setItemMeta(meta);
                inv.setItem(i, gem_item);
            }
        }
    }

    public static List<String> getGemCheckList(ItemStack item) {
        ItemMeta meta = item.getItemMeta();
        List<String> lore = meta.getLore();
        List<String> GemList = new ArrayList<>();
        for (int i = 0; i < lore.size(); i++) {
            String s = lore.get(i);
            if (s.startsWith("§1§6§r§8- §8< ")) {
                if (Main.GemHashMap.get(s) != null) {
                    String GemKey = Main.GemHashMap.get(s);
                    GemList.add(GemKey + "#" + i);
                }
            }
        }
        return GemList;
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 27, "战争领域 - 宝石拆除台");
        for (int i = 0; i < 9; i++) {
            inv.setItem(i, glass(0, "§7[§c宝石槽§7]"));
        }
        for (int i = 9; i < 27; i++) {
            inv.setItem(i, glass(15, "§r"));
        }
        inv.setItem(19, glass(4, "§7[[§a▧▧§7]]"));
        inv.setItem(20, glass(0, "§7[§6装备槽§7]"));
        inv.setItem(21, glass(4, "§7[[§a▧▧§7]]"));

        inv.setItem(25, glass(1, "§7[[§a▧▧§7]]"));
        inv.setItem(24, glass(0, "§7[§6拆除器§7]"));
        inv.setItem(23, glass(1, "§7[[§a▧▧§7]]"));
        p.openInventory(inv);
    }


    public static ItemStack glass(int data, String name) {
        ItemStack item = new ItemStack(160, 1, (short) data);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }
}
